/*
 * Copyright (c) 2012, Codename One and/or its affiliates. All rights reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * This code is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 only, as
 * published by the Free Software Foundation.  Codename One designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Oracle in the LICENSE file that accompanied this code.
 *  
 * This code is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * version 2 for more details (a copy is included in the LICENSE file that
 * accompanied this code).
 * 
 * You should have received a copy of the GNU General Public License version
 * 2 along with this work; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 * 
 * Please contact Codename One through http://www.codenameone.com/ if you 
 * need additional information or have any questions.
 */
package com.codename1.impl.android;

//import com.codename1.tests.webpush.WebPushTestStub;

/**
 * This class will be modified by the build server to return the correct Application stub class
 * for the built application.  This is used to try to minimize the amount of code that needs to be
 * generated by the server.  Classes in the android implementation can use the StubUtil static methods
 * instead of needing to have code injected by the build server.  
 * 
 * The build server will replace all instances of "//!" (without quotes) with "" (without quotes).
 * And  "{{Stub}}" (without quotes) with the fully qualified class name of the app stub.
 * @author shannah
 */
public class StubUtil {

    static boolean appIsRunning() {
        if (true) {
            //!return {{Stub}}.isRunning();
        }
        if (true) {
            //return WebPushTestStub.isRunning();
        }
        return false;
    }


    static Class getAppStubClass() {
        if (true) {
            //!return {{Stub}}.class;
        }
        if (true) {
            //return WebPushTestStub.class;
        }
        return null;

    }

    static Object getMain() {
        if (true) {
            //!return {{Stub}}.getAppInstance();
        }
        if (true) {
            //return WebPushTestStub.getAppInstance();
        }

        return null;
    }
}
